/*
 * Copyright (c) 2006-2008 ITRI. All rights reserved.
 * 
 * Module name: CITRIC cameraboard API ITRI 
 *          
 * Abstact : CITRIC cameraboard API ITRI
 * 
 * This program is free software; you can redistribute  it and/or modify it
 * under  the terms of  the GNU General  Public License as published by the
 * Free Software Foundation;  either version 2 of the  License, or (at your
 * option) any later version.
 *
 */

#ifndef CAMERABOARD_H
#define CAMERABOARD_H

enum {
	IMG_COLOR_YUV_422,
	IMG_COLOR_GBR_422,
};

enum {
	IMG_RES_VGA,
	IMG_RES_QVGA,
	IMG_RES_QQVGA,
};

typedef struct cameraboard {
	unsigned char* img;
	int img_width;
	int img_height;
	int img_length;
	unsigned long img_time;
} cameraboard;

#ifdef __cplusplus
	extern "C" {
#endif

void camera_set_autoexp(int x);

cameraboard* cameraboard_open(int img_color0, int img_res0, int auto_exposure);

void cameraboard_close();

int camera_capture_frame();

void camera_calibrate_exp(int calibration_time, int auto_exp_on, int verbose);

int cbpkt_send(unsigned char type, unsigned int dest, unsigned char* payload, unsigned int length);

int cbpkt_rcv(unsigned char* type, unsigned int* src_id_actual, unsigned char* payload, unsigned int* length);

int outqueue_is_full();

int inqueue_is_empty();

void cameraboard_sync_time();

unsigned long cameraboard_get_time();

void write_binary_image(unsigned char* buf, int image_width, int image_height, char* fn, int color);

void write_jpeg_image(unsigned char* buf, int w, int h, char* fn, int color, int quality);

int get_cbprintf_group(int groupnum);

void set_cbprintf_group(int groupnum, int value);

void cbprintf(int groupnum, char* format, ...);

void send_file(int dest, char* fn);

#ifdef __cplusplus
	}
#endif

#endif
