#define CAMREG_VREF			0x03
#define CAMREG_COM1			0x04
#define CAMREG_COM5			0x0E
#define CAMREG_COM6			0x0F
#define CAMREG_CLKRC		0x11
#define CAMREG_COM7			0x12
#define CAMREG_COM8			0x13
#define CAMREG_COM9			0x14
#define CAMREG_REG16		0x16
#define CAMREG_HSTART		0x17
#define CAMREG_HSTOP		0x18
#define CAMREG_VSTART		0x19
#define CAMREG_VSTOP		0x1A
#define CAMREG_MVFP			0x1E
#define CAMREG_AEW			0x24
#define CAMREG_AEB			0x25
#define CAMREG_VPT			0x26
#define CAMREG_BBIAS		0x27
#define CAMREG_GBIAS		0x28
#define CAMREG_PREGAIN	0x29
#define CAMREG_RBIAS		0x2C
#define CAMREG_HREF			0x32
#define CAMREG_AREF3		0x36
#define CAMREG_ADC2			0x38
#define CAMREG_AREF4		0x39
#define CAMREG_TSLB			0x3A
#define CAMREG_COM11		0x3B
#define CAMREG_COM14		0x3E
#define CAMREG_EDGE			0x3F
#define CAMREG_COM16		0x41
#define CAMREG_COM17		0x42
#define CAMREG_MTX1			0x4F
#define CAMREG_MTX2			0x50
#define CAMREG_MTX3			0x51
#define CAMREG_MTX4			0x52
#define CAMREG_MTX5			0x53
#define CAMREG_MTX6			0x54
#define CAMREG_DBLV			0x6B	//added by leon 20080707
#define CAMREG_POIDX		0x72
#define CAMREG_PCKDV		0x73
#define CAMREG_XINDX		0x74
#define CAMREG_YINDX		0x75
#define CAMREG_COM19		0x8C
#define CAMREG_COM24		0xC7

static unsigned char camera_regs[208];

// VGA 30fps mode
void init_camera_regs() {
	camera_regs[0x11] = 0x01;
	//camera_regs[0x6b] = 0x5a;
	camera_regs[0x6b] = 0x4a; // clock doubling to get 30fps
	camera_regs[0x12] = 0x62;
	camera_regs[0x36] = 0xfa;
	camera_regs[0x69] = 0x0a;
	camera_regs[0x8c] = 0x89;
	camera_regs[0x3e] = 0x0c;
	camera_regs[0x41] = 0x00;
	camera_regs[0x72] = 0x00;
	camera_regs[0x73] = 0x00;
	camera_regs[0x74] = 0x3a;
	camera_regs[0x75] = 0x35;
	camera_regs[0x76] = 0x01;
	camera_regs[0xc7] = 0x80;
	camera_regs[0x03] = 0x12;
	camera_regs[0x17] = 0x16;
	camera_regs[0x18] = 0x02;
	camera_regs[0x19] = 0x01;
	camera_regs[0x1a] = 0x3d;
	camera_regs[0x32] = 0xff;
	camera_regs[0xc0] = 0xaa;
	camera_regs[0x3a] = 0x0c;
	camera_regs[0x13] = 0x00;
	camera_regs[0x00] = 0x00;
	camera_regs[0x01] = 0x80;
	camera_regs[0x02] = 0x80;
	camera_regs[0x04] = 0x03;
	camera_regs[0x0b] = 0x57;
	camera_regs[0x0e] = 0x61;
	camera_regs[0x0f] = 0x42;
	camera_regs[0x10] = 0xf0;
	camera_regs[0xa1] = 0x40;
	camera_regs[0xa6] = 0x4a;
	camera_regs[0x16] = 0x24;
	camera_regs[0x1e] = 0x04;
	camera_regs[0x29] = 0x15;
	camera_regs[0xa9] = 0xef;
	camera_regs[0x27] = 0x08;
	camera_regs[0x28] = 0x08;
	camera_regs[0x2a] = 0x00;
	camera_regs[0x2b] = 0x00;
	camera_regs[0x2c] = 0x08;
	camera_regs[0x33] = 0x00;
	camera_regs[0x34] = 0x3f;
	camera_regs[0x35] = 0x00;
	camera_regs[0x38] = 0x72;
	camera_regs[0x39] = 0x57;
	camera_regs[0x3d] = 0x99;
	camera_regs[0x40] = 0xc0;
	camera_regs[0x4a] = 0xfc;
	camera_regs[0x4b] = 0xfc;
	camera_regs[0x4c] = 0x7f;
	camera_regs[0x4d] = 0x7f;
	camera_regs[0x4e] = 0x7f;
	camera_regs[0x5f] = 0xf0;
	camera_regs[0x60] = 0xf0;
	camera_regs[0x61] = 0xf0;
	camera_regs[0x42] = 0xc0;
	camera_regs[0x3f] = 0xc1;
	camera_regs[0x76] = 0x01;
	camera_regs[0x70] = 0x21;
	camera_regs[0x77] = 0x02;
	camera_regs[0x55] = 0x00;
	camera_regs[0x56] = 0x40;
	camera_regs[0x57] = 0x80;
	camera_regs[0x3c] = 0x0c;
	camera_regs[0x7a] = 0x19;
	camera_regs[0x7b] = 0x06;
	camera_regs[0x7c] = 0x0e;
	camera_regs[0x7d] = 0x20;
	camera_regs[0x7e] = 0x42;
	camera_regs[0x7f] = 0x52;
	camera_regs[0x80] = 0x62;
	camera_regs[0x81] = 0x70;
	camera_regs[0x82] = 0x7f;
	camera_regs[0x83] = 0x8b;
	camera_regs[0x84] = 0x95;
	camera_regs[0x85] = 0xa6;
	camera_regs[0x86] = 0xb5;
	camera_regs[0x87] = 0xcc;
	camera_regs[0x88] = 0xdd;
	camera_regs[0x89] = 0xed;
	camera_regs[0x8a] = 0x03;
	camera_regs[0x90] = 0x7d;
	camera_regs[0x91] = 0x7b;
	camera_regs[0x9f] = 0x7a;
	camera_regs[0xa0] = 0x79;
	camera_regs[0xa4] = 0x50;
	camera_regs[0xa8] = 0xc1;
	camera_regs[0xa9] = 0xef;
	camera_regs[0xaa] = 0x92;
	camera_regs[0xab] = 0x04;
	camera_regs[0xac] = 0x80;
	camera_regs[0xad] = 0x80;
	camera_regs[0xae] = 0x80;
	camera_regs[0xaf] = 0x80;
	camera_regs[0xb2] = 0xf2;
	camera_regs[0xb3] = 0x20;
	camera_regs[0xb4] = 0x26;
	camera_regs[0xb5] = 0x00;
	camera_regs[0xb6] = 0xaf;
	camera_regs[0xbb] = 0xae;
	camera_regs[0xbc] = 0x7f;
	camera_regs[0xbd] = 0x7f;
	camera_regs[0xbe] = 0x7f;
	camera_regs[0xbf] = 0x7f;
	camera_regs[0xc1] = 0xc0;
	camera_regs[0xc2] = 0x01;
	camera_regs[0xc3] = 0x4e;
	camera_regs[0x24] = 0x40;
	camera_regs[0x25] = 0x30;
	camera_regs[0x26] = 0x82;
	camera_regs[0xC6] = 0x05;
	camera_regs[0xcd] = 0x93;
	camera_regs[0x71] = 0x78;
	camera_regs[0xa5] = 0x68;
	camera_regs[0xca] = 0xe8;
	camera_regs[0xc9] = 0xe0;
	camera_regs[0xcB] = 0xf0;
	camera_regs[0xcc] = 0xd8;
	camera_regs[0x14] = 0x2a;
	camera_regs[0x3b] = 0x44;
	camera_regs[0x4f] = 0x90;
	camera_regs[0x50] = 0x89;
	camera_regs[0x51] = 0x07;
	camera_regs[0x52] = 0x0f;
	camera_regs[0x53] = 0x93;
	camera_regs[0x54] = 0xa1;
	camera_regs[0x58] = 0x9e;
	camera_regs[0x43] = 0x14;
	camera_regs[0x44] = 0xf0;
	camera_regs[0x45] = 0x3e;
	camera_regs[0x46] = 0x5f;
	camera_regs[0x47] = 0x2a;
	camera_regs[0x48] = 0x3f;
	camera_regs[0x59] = 0xcd;
	camera_regs[0x5a] = 0xb9;
	camera_regs[0x5b] = 0xdf;
	camera_regs[0x5c] = 0x76;
	camera_regs[0x5d] = 0x4d;
	camera_regs[0x5e] = 0x11;
	camera_regs[0x6c] = 0x00;
	camera_regs[0x6d] = 0x55;
	camera_regs[0x6e] = 0x11;
	camera_regs[0x6f] = 0x9e;
	camera_regs[0x62] = 0x00;
	camera_regs[0x63] = 0x1a;
	camera_regs[0x64] = 0x04;
	camera_regs[0x65] = 0x00;
	camera_regs[0x66] = 0x05;
	camera_regs[0x9d] = 0x04;
	camera_regs[0x9e] = 0x04;
	camera_regs[0x3a] = 0x0c;
	camera_regs[0x6a] = 0x2;
	camera_regs[0xc5] = 0x3;
	camera_regs[0xa2] = 0x96;
	camera_regs[0xa3] = 0x7d;
	camera_regs[0x13] = 0xe7;
	camera_regs[0x42] = 0xc0;
}

// camera registers to be written to camera
// VGA 30fps mode
unsigned char camera_regs_write[] =
{
0x11,
0x6b,
0x12,
0x36,
0x69,
0x8c,
0x3e,
0x41,
0x72,
0x73,
0x74,
0x75,
0x76,
0xc7,
0x03,
0x17,
0x18,
0x19,
0x1a,
0x32,
0xc0,
0x3a,
0x13,
0x00,
0x01,
0x02,
0x04,
0x0b,
0x0e,
0x0f,
0x10,
0xa1,
0xa6,
0x16,
0x1e,
0x29,
0xa9,
0x27,
0x28,
0x2a,
0x2b,
0x2c,
0x33,
0x34,
0x35,
0x38,
0x39,
0x3d,
0x40,
0x4a,
0x4b,
0x4c,
0x4d,
0x4e,
0x5f,
0x60,
0x61,
0x42,
0x3f,
0x76,
0x70,
0x77,
0x55,
0x56,
0x57,
0x3c,
0x7a,
0x7b,
0x7c,
0x7d,
0x7e,
0x7f,
0x80,
0x81,
0x82,
0x83,
0x84,
0x85,
0x86,
0x87,
0x88,
0x89,
0x8a,
0x90,
0x91,
0x9f,
0xa0,
0xa4,
0xa8,
0xa9,
0xaa,
0xab,
0xac,
0xad,
0xae,
0xaf,
0xb2,
0xb3,
0xb4,
0xb5,
0xb6,
0xbb,
0xbc,
0xbd,
0xbe,
0xbf,
0xc1,
0xc2,
0xc3,
0x24,
0x25,
0x26,
0xC6,
0xcd,
0x71,
0xa5,
0xca,
0xc9,
0xcB,
0xcc,
0x14,
0x3b,
0x4f,
0x50,
0x51,
0x52,
0x53,
0x54,
0x58,
0x43,
0x44,
0x45,
0x46,
0x47,
0x48,
0x59,
0x5a,
0x5b,
0x5c,
0x5d,
0x5e,
0x6c,
0x6d,
0x6e,
0x6f,
0x62,
0x63,
0x64,
0x65,
0x66,
0x9d,
0x9e,
0x3a,
0x6a,
0xc5,
0xa2,
0xa3,
0x13,
0x42,
};

/*
void init_camera_regs() {
}

// camera registers to be written to camera
unsigned char camera_regs_write[] =
{
	CAMREG_COM7,
	CAMREG_COM8,
	CAMREG_HSTART, CAMREG_HSTOP,
	CAMREG_VSTART, CAMREG_VSTOP,
	//CAMREG_CLKRC,
	//CAMREG_DBLV,	//added by leon 20080707
};
*/
