#ifndef GLOBAL_H
#define GLOBAL_H

#include "citric_packet.h"

// SOME DATA TYPES:
#define xshort unsigned char
#define IplImagep IplImage*


/*! Maximum size of packet received from mote. */
#define MAX_PACKET_LEN 200
/*! Size of the buffer containing the packets. */
#define QUEUE_SIZE 1000
/*! Maximum number of motes allowed. */
#define MAX_MOTES_NUMBER 100


/*! Some genering functions to recover information from a camera board (CB)
		packet. These are the access function. They will have to be updated
		if the mote packet format changes. */
// Returns CB pkt type
#define MSG_IS_CB_PKT(msg) ( AMPKT_GET_HANDLERID((msg)+SERIALPKT_HEADER_LENGTH)==HANDLERID_CITRIC )
// Gets the CB packet type
#define MSG_GET_PKTTYPE(msg) ( CBPKT_GET_TYPE((msg)+SERIALPKT_HEADER_LENGTH+AMPKT_HEADER_LENGTH) )
// Mote ID
#define MSG_GET_MOTEID(msg) ( CBPKT_GET_ACTUALSRCID((msg)+SERIALPKT_HEADER_LENGTH+AMPKT_HEADER_LENGTH) )
// Returns pointer to CB payload
#define MSG_GET_PKT(msg) ( (msg)+SERIALPKT_HEADER_LENGTH+AMPKT_HEADER_LENGTH+CBPKT_HEADER_LENGTH )
// Returns size of CB payload
#define MSG_GET_PKTSZ(msg) ( AMPKT_GET_PAYLOADLENGTH((msg)+SERIALPKT_HEADER_LENGTH)-CBPKT_HEADER_LENGTH )


#endif
