// TOS 2.1.0

#ifndef CITRIC_PACKET_H
#define CITRIC_PACKET_H

// Serial Packet
enum {
	SERIALPKT_HEADER_LENGTH = 3,
	SERIALPKT_FOOTER_LENGTH = 2,
};

// AM Packet
enum {
	AMPKT_HEADER_LENGTH = 7,
	AMPKT_MAX_PAYLOAD = 114,
};

// AM Packet handler ID
enum {
	HANDLERID_CITRIC =  0x77,
};

// AM Packet accessors
#define AMPKT_GET_DESTID(ampkt) ((((unsigned int) (ampkt)[0])<<8) + (ampkt)[1])
#define AMPKT_SET_DESTID(ampkt,x) (ampkt)[0] = ((x)>>8) & 0xFF; (ampkt)[1] = (x) & 0xFF

#define AMPKT_GET_SRCID(ampkt) ((((unsigned int) (ampkt)[2])<<8) + (ampkt)[3])
#define AMPKT_SET_SRCID(ampkt,x) (ampkt)[2] = ((x)>>8) & 0xFF; (ampkt)[3] = (x) & 0xFF

#define AMPKT_GET_PAYLOADLENGTH(ampkt) ((unsigned int) (ampkt)[4])
#define AMPKT_SET_PAYLOADLENGTH(ampkt,x) (ampkt)[4] = (x) & 0xFF

#define AMPKT_GET_GROUPID(ampkt) ((unsigned int) (ampkt)[5])
#define AMPKT_SET_GROUPID(ampkt,x) (ampkt)[5] = (x) & 0xFF

#define AMPKT_GET_HANDLERID(ampkt) ((unsigned int) (ampkt)[6])
#define AMPKT_SET_HANDLERID(ampkt,x) (ampkt)[6] = (x) & 0xFF

// CB packet
enum {
	CBPKT_HEADER_LENGTH = 3,
};

#define CBPKT_MAX_PAYLOAD (AMPKT_MAX_PAYLOAD - CBPKT_HEADER_LENGTH)

// CB Packet accessors
//#define CBPKT_GET_TYPE(cbpkt) ((unsigned int) (cbpkt)[0])
#define CBPKT_GET_TYPE(cbpkt) (((unsigned char*)cbpkt)[0])
//#define CBPKT_SET_TYPE(cbpkt,x) (cbpkt)[0] = (x) & 0xFF
#define CBPKT_SET_TYPE(cbpkt,x) CBPKT_GET_TYPE(cbpkt) = (unsigned char)x;

//#define CBPKT_GET_ACTUALSRCID(cbpkt) ((((unsigned int) (cbpkt)[1])<<8) + (cbpkt)[2])
#define CBPKT_GET_ACTUALSRCID(cbpkt) ((((unsigned short)(((unsigned char*)cbpkt)[1])) << 8) + (unsigned short)(((unsigned char*)cbpkt)[2]))
//#define CBPKT_SET_ACTUALSRCID(cbpkt,x) (cbpkt)[1] = ((x)>>8) & 0xFF; (cbpkt)[2] = (x) & 0xFF
#define CBPKT_SET_ACTUALSRCID(cbpkt,x) ((unsigned char*)cbpkt)[1] = ((unsigned short)x) & 0xFF00; ((unsigned char*)cbpkt)[2] = ((unsigned short)x) & 0xFF

// CB packet types
enum {
	CB_TYPE_PINGREQ = 0x00,
	CB_TYPE_PING = 0x01,
	CB_TYPE_SET = 0x02,
	CB_TYPE_PRINTFCONFIG = 0x03,
	CB_TYPE_PRINTF = 0x04,
	CB_TYPE_FILEINFO = 0x05,
	CB_TYPE_FILE = 0x06,
	CB_TYPE_TIMESYNC = 0x07,
	CB_TYPE_CAMERASYNC = 0x08,
	CB_TYPE_RETRANSREQ = 0x09,
	CB_TYPE_TIMECOMP = 0x0A,
	CB_TYPE_NOINCOMING = 0x0B,
	CB_TYPE_NOOUTGOING = 0x0C,
	CB_TYPE_TIMEREFLECT = 0x0D,
};

#endif
