#include "_LinuxSocket.h"

#include <stdio.h>
#include <unistd.h>
#include <string.h>
#include <sys/types.h> 
#include <sys/socket.h>
#include <netinet/in.h>
#include <pthread.h>

int sockfd, newsockfd[256], num_clients, clilen;
struct sockaddr_in serv_addr, cli_addr;
pthread_t t1;

void* clientThread(void* params)
{
	while(1)
	{
		newsockfd[num_clients] = accept(sockfd, (struct sockaddr *) &cli_addr, (socklen_t*)&clilen);
		if (newsockfd[num_clients] < 0)
		{
			printf("ERROR on accept");
		}
		else
		{
			num_clients++;
		}
	}
}

void startSocket()
{
	sockfd = socket(AF_INET, SOCK_STREAM, 0);
	if (sockfd < 0) printf("ERROR opening socket\n");

	bzero((char *) &serv_addr, sizeof(serv_addr));

	serv_addr.sin_family = AF_INET;
	serv_addr.sin_addr.s_addr = INADDR_ANY;
	serv_addr.sin_port = htons(PORTNUM);

	if (bind(sockfd, (struct sockaddr *) &serv_addr, sizeof(serv_addr)) < 0) printf("ERROR on binding");

	printf("Using TCP Socket port %d\n",PORTNUM);

	listen(sockfd,5);
	clilen = sizeof(cli_addr);
	num_clients = 0;
  pthread_create(&t1, NULL, clientThread, NULL);
}

int writeSocket(unsigned char* data, int length)
{
	int i,j;

	for (j=0; j<num_clients; j++)
	{
		i = write(newsockfd[j],data,length);
		if (i < 0)
		{
			printf("ERROR writing to socket, client %d", j);
		}
	}

	return 0;
}
