#ifndef MOTECOMM_H
#define MOTECOMM_H

#ifdef __linux
#else
	#include <WinSock2.h>
	#include <tchar.h>
#endif

#include <stdio.h>
#include <iostream>
#include <fstream>
#include <string>

#ifdef __linux
	#include <pthread.h>
#else
	#include <process.h>
#endif

#include "../C-Common/_Global.h"

using namespace std;

/*! Global variable storing the port used for stream of packets. */
extern char MCOMM_PORT[];
/*! Global variable storing display mode for the streamed packets.*/
extern int MCOMM_DISPLAY;
/*! Global variable determining if a log file will be created or not.*/
extern int MCOMM_LOG;

/*! Options for display of streamed packets. */
enum{
	MCOMM_DISPLAY_OFF = 0,
	MCOMM_DISPLAY_HEX = 1,
	MCOMM_DISPLAY_DEC = 2,
  MCOMM_DISPLAY_CHAR = 3
};

void StartMoteConnection();
void ProcessPacket(xshort* msg, int msgSz);
void SendToMote(char* data,int dataSz);
int CreateTinyOSMsg(char* msg, int dest, int pktType, char* data, int dataSz);

#endif