#ifndef SERVERMENU_H
#define SERVERMENU_H

#include <iostream>
#include <fstream>
using namespace std;

/*! Variable containing the list of motes selected. */
extern int SMENU_MOTELIST[];
/*! Size of the list of motes selected. */
extern int SMENU_MOTELISTSZ;
/*! Variable indicating if log of packets is on. */
extern int SMENU_LOG_ON;

/*! Options for the MAIN menu. */
enum{
	MENU_MAIN_EXIT = 0,
	MENU_MAIN_SELECTION = 1,
	MENU_MAIN_DISPLAY = 2,
  MENU_MAIN_LOG = 3,
	MENU_MAIN_SEND = 4,
	MENU_MAIN_STATUS = 5,
	MENU_MAIN_RUNSAMPLE = 6
};

/*! Options for the MOTE SELECTION menu. */
enum{
	MENU_SELECTION_LOAD = 1,
	MENU_SELECTION_SET = 2,
	MENU_SELECTION_SAVE = 3
};

/*! Options for the DISPLAY menu. */
enum{
	MENU_DISPLAY_DEC = 1,
	MENU_DISPLAY_HEX = 2,
  MENU_DISPLAY_CHAR = 3,
	MENU_DISPLAY_PRINTF = 4
};

/*! Options for the LOG menu. */
enum{
  MENU_LOG_START = 1,
  MENU_LOG_STOP = 2
};

/*! Options for the SEND menu. */
enum{
	MENU_SEND_STOPSYNCH = 1,
	MENU_SEND_PING = 2,
	MENU_SEND_SETPARAM = 3,
	MENU_SEND_SETPRINTF = 4,
	MENU_SEND_FILE = 5
};

int InputMainMenu();
int InputDisplayMenu();
void InterpretTextList(char* buf);
int InputMoteSelectionMenu();
int InputLogMenu();
int InputSendMenu();

#endif
