% vcibf - view camera board images - IM BG FG

clear IM*
clear BG*
clear FG*

imdir = './';

% get number of frames
fstruct = struct2cell(dir([imdir 'im*']));
numframes = size(fstruct,2);
fnames = fstruct(1,:);

% init mean exposure
mean_exp = [];

% draw IM, BG and FG for each frame
for i=1:numframes
	% init figure
	figure;
	colormap(gray);

	fname = fnames{i};
	fnamebg = strrep(fname,'im','bg');
	fnamefg = strrep(fname,'im','fg');
	
	% draw IM
	subplot(1,3,1);
	eval([fname ' = ' 'read_camera_img(''' imdir fname ''');']);
	eval(['imagesc(' fname ')']);
	
	eval(['mean_exp = [mean_exp mean(mean(' fname '))];']);
	
	% draw BG
	subplot(1,3,2);
	if (fname(3:6) == '0000') % if filename is IM0000
		 imagesc([0]);
	else
			eval([fnamebg ' = ' 'read_camera_img(''' imdir fnamebg ''');']);
			eval(['imagesc(' fnamebg ')']);
	end
	
	% draw FG
	subplot(1,3,3);
	if (fname(3:6) == '0000') % if filename is IM0000
		 imagesc([0]);
	else
			eval([fnamefg ' = ' 'read_camera_img(''' imdir fnamefg ''');']);
			eval(['imagesc(' fnamefg ')']);
	end
	
	set(gcf,'NumberTitle', 'off');
	set(gcf,'Name', [fname ' ' fnamebg ' ' fnamefg]);
end

mean_exp